#include "defsetupM.h"

#define PTRSIZE 4
#define DATASTEP (REGSIZE)
#define TEMPSTEP 4*PTRSIZE

int alignwidth=DATASTEP*int((width+DATASTEP-1)/DATASTEP);
int negalignwidth=-alignwidth;

_declspec(align(16)) unsigned char rounder[16];
_declspec(align(16)) unsigned char* rowendptrs[8];// needs constant :-(

for (int j=0;j<16;++j)
	rounder[j] = 0x80;
for (int i=0;i<8;++i)
	rowendptrs[i]=frameptrs[i]+alignwidth;


//this is 8bit only
__asm
{
	pushad

mov		eax, [rowendptrs]//dst
mov		ebx, [rowendptrs+2*PTRSIZE]//c1
mov		ecx, [rowendptrs+4*PTRSIZE]//c2
mov		edx, [rowendptrs+6*PTRSIZE]//mask

movdqa		xmm7,[rounder]

mov		esi, [s_height]

LABEL_VERTICAL:
	mov		edi, [negalignwidth]

LABEL_HORIZONTAL:
	//mm 3, mov 8, sub 4, pac 6, shi 2, mul 2 ..1.4.1
	//mm 3, mov 7, s/a 5, pac 6, shi 2, mul 2 cmp 1  ..1.4.2
		movdqa		xmm1, xmmword ptr [ebx+edi]		//c1
		movdqa		xmm2, xmmword ptr [ecx+edi]		//c2
		movdqa		xmm3, xmmword ptr [edx+edi]		//m
//(c1-128)*(255-m)+(c2-128)*m+128*256+c1
		pcmpeqb		xmm4, xmm4	//255
		movdqa		xmm0, xmm1	//c1
		psubb		xmm1, xmm7	//c1-128
		psubb		xmm2, xmm7	//c2-128
		psubb		xmm4, xmm3	//255-m

		movdqa		xmm5, xmm2	//c2-128
		movdqa		xmm6, xmm3	//m

		punpcklbw	xmm3, xmm4	//255,m
		punpcklbw	xmm2, xmm1	//c1c2
		punpckhbw	xmm6, xmm4	//255,m
		punpckhbw	xmm5, xmm1	//c1c2

		pmaddubsw	xmm3, xmm2	//low
		pmaddubsw	xmm6, xmm5	//high

		movdqa		xmm1, xmm0	//c1

		punpcklbw	xmm0, xmm7	//128*256+c1
		punpckhbw	xmm1, xmm7	//128*256+c1

		paddw		xmm3, xmm0
		paddw		xmm6, xmm1
//    r/256
		psrlw		xmm3, 8
		psrlw		xmm6, 8

		packuswb	xmm3, xmm6

		movdqa		xmmword ptr [eax+edi], xmm3
		add		edi, DATASTEP
		jnz LABEL_HORIZONTAL

	add		eax, [pitches]
	add		ebx, [pitches+8]
	add		ecx, [pitches+16]
	add		edx, [pitches+24]

	dec		esi
	jnz LABEL_VERTICAL

emms
popad
}

SuccesfullyDone=true;

#include "defresetM.h"