const int scaleUPpower   =( lsb & 1 ? ScaleM16CPPpower : ScaleM8CPPpower );
const int scaleDOWNpower =( lsb & 2 ? ScaleM16CPPpower : ScaleM8CPPpower );
const int scaleFINALpower=( 2*scaleUPpower - scaleDOWNpower);
const int scaleFINAL     =  1 << scaleFINALpower;
switch (lsb)
{
case 1://16bit in 8bit out
	{
//		long long roundedbias=long long((bias+0.5)*scaleFINAL+0.5);
//		long long roundedbias=long long((bias+0.5)*ScaleM16CPP+0.5);
		long long roundedbias=long long((bias+0.5)*ScaleM16CPP*ScaleM8CPP+0.5);
		for (int y = 0; y < s_height; ++y)
		{
			for (int x = 0; x < width; x+=1)
			{
				long long sum0 = roundedbias;
				for (int i=4; i<(length+1)*4;i+=4) {
					sum0 += ((frameptrs[i+1][x])+((frameptrs[i][x])<<8))*((frameptrs[i+3][x])+(unsigned int(frameptrs[i+2][x])<<8));
				}
				unsigned int a = unsigned int(max( min (sum0>>24,255),0));
//				frameptrs[1][x] =(a % 256);
//				frameptrs[0][x] =(a >> 8);
				frameptrs[0][x] =a;
			}
			for (int i=0;i<(length+1)*4;++i)
				frameptrs[i] += pitches[i];
		}
	}
	break;
case 2: //8bit in 16bit out
	{
		int roundedbias=int((bias));//+0.5
		for (int y = 0; y < s_height; ++y)
		{
			for (int x = 0; x < width; x+=1)
			{
				int sum0 = roundedbias;
				for (int i=4; i<(length+1)*4;i+=4) {
//					sum0 += ((frameptrs[i+1][x])+((frameptrs[i][x])<<8))*((frameptrs[i+3][x])+(unsigned int(frameptrs[i+2][x])<<8));
					sum0 += frameptrs[i][x]*frameptrs[i+2][x];
				}
				unsigned int a = unsigned int(max( min (sum0,65535),0));
				frameptrs[1][x] =(a % 256);
				frameptrs[0][x] =(a >> 8);
			}
			for (int i=0;i<(length+1)*4;++i)
				frameptrs[i] += pitches[i];
		}
	}
	break;
case 3: //16bit in 16bit out
	{
		long long roundedbias=long long((bias+0.5)*scaleFINAL+0.5);
		unsigned int a0,a1,a2,a3,a4,a5,a6,a7;
		for (int y = 0; y < s_height; ++y)
		{
			for (int x = 0; x < width; x+=8)
			{
				long long sum0 = roundedbias;
				long long sum1 = roundedbias;
				long long sum2 = roundedbias;
				long long sum3 = roundedbias;
				long long sum4 = roundedbias;
				long long sum5 = roundedbias;
				long long sum6 = roundedbias;
				long long sum7 = roundedbias;
				for (int i=4; i<(length+1)*4;i+=4) {
					sum0 += ((frameptrs[i+1][x])+((frameptrs[i][x])<<8))*((frameptrs[i+3][x])+(unsigned int(frameptrs[i+2][x])<<8));
					sum1 += ((frameptrs[i+1][x+1])+((frameptrs[i][x+1])<<8))*((frameptrs[i+3][x+1])+(unsigned int(frameptrs[i+2][x+1])<<8));
					sum2 += ((frameptrs[i+1][x+2])+((frameptrs[i][x+2])<<8))*((frameptrs[i+3][x+2])+(unsigned int(frameptrs[i+2][x+2])<<8));
					sum3 += ((frameptrs[i+1][x+3])+((frameptrs[i][x+3])<<8))*((frameptrs[i+3][x+3])+(unsigned int(frameptrs[i+2][x+3])<<8));
					sum4 += ((frameptrs[i+1][x+4])+((frameptrs[i][x+4])<<8))*((frameptrs[i+3][x+4])+(unsigned int(frameptrs[i+2][x+4])<<8));
					sum5 += ((frameptrs[i+1][x+5])+((frameptrs[i][x+5])<<8))*((frameptrs[i+3][x+5])+(unsigned int(frameptrs[i+2][x+5])<<8));
					sum6 += ((frameptrs[i+1][x+6])+((frameptrs[i][x+6])<<8))*((frameptrs[i+3][x+6])+(unsigned int(frameptrs[i+2][x+6])<<8));
					sum7 += ((frameptrs[i+1][x+7])+((frameptrs[i][x+7])<<8))*((frameptrs[i+3][x+7])+(unsigned int(frameptrs[i+2][x+7])<<8));
				}
				a0 = unsigned int(max( min (sum0>>scaleFINALpower,(1<<scaleDOWNpower)-1),0));
				a1 = unsigned int(max( min (sum1>>scaleFINALpower,(1<<scaleDOWNpower)-1),0));
				a2 = unsigned int(max( min (sum2>>scaleFINALpower,(1<<scaleDOWNpower)-1),0));
				a3 = unsigned int(max( min (sum3>>scaleFINALpower,(1<<scaleDOWNpower)-1),0));
				a4 = unsigned int(max( min (sum4>>scaleFINALpower,(1<<scaleDOWNpower)-1),0));
				a5 = unsigned int(max( min (sum5>>scaleFINALpower,(1<<scaleDOWNpower)-1),0));
				a6 = unsigned int(max( min (sum6>>scaleFINALpower,(1<<scaleDOWNpower)-1),0));
				a7 = unsigned int(max( min (sum7>>scaleFINALpower,(1<<scaleDOWNpower)-1),0));
				frameptrs[1][x] =(a0 % 256);
				frameptrs[1][x+1] =(a1 % 256);
				frameptrs[1][x+2] =(a2 % 256);
				frameptrs[1][x+3] =(a3 % 256);
				frameptrs[1][x+4] =(a4 % 256);
				frameptrs[1][x+5] =(a5 % 256);
				frameptrs[1][x+6] =(a6 % 256);
				frameptrs[1][x+7] =(a7 % 256);
				frameptrs[0][x] =(a0 >> 8);
				frameptrs[0][x+1] =(a1 >> 8);
				frameptrs[0][x+2] =(a2 >> 8);
				frameptrs[0][x+3] =(a3 >> 8);
				frameptrs[0][x+4] =(a4 >> 8);
				frameptrs[0][x+5] =(a5 >> 8);
				frameptrs[0][x+6] =(a6 >> 8);
				frameptrs[0][x+7] =(a7 >> 8);
			}
			for (int i=0;i<(length+1)*4;++i)
				frameptrs[i] += pitches[i];
		}
	}
	break;
default: //8bit in 8bit out
	{
		int roundedbias=int((bias+0.5)*256+0.5);
		for (int y = 0; y < s_height; ++y)
		{
			for (int x = 0; x < width; x+=8)
			{
				int sum0 = roundedbias;
				int sum1 = roundedbias;
				int sum2 = roundedbias;
				int sum3 = roundedbias;
				int sum4 = roundedbias;
				int sum5 = roundedbias;
				int sum6 = roundedbias;
				int sum7 = roundedbias;
				for (int i=4; i<(length+1)*4;i+=4) {
					sum0 += frameptrs[i][x]*frameptrs[i+2][x];
					sum1 += frameptrs[i][x+1]*frameptrs[i+2][x+1];
					sum2 += frameptrs[i][x+2]*frameptrs[i+2][x+2];
					sum3 += frameptrs[i][x+3]*frameptrs[i+2][x+3];
					sum4 += frameptrs[i][x+4]*frameptrs[i+2][x+4];
					sum5 += frameptrs[i][x+5]*frameptrs[i+2][x+5];
					sum6 += frameptrs[i][x+6]*frameptrs[i+2][x+6];
					sum7 += frameptrs[i][x+7]*frameptrs[i+2][x+7];
				}
				frameptrs[0][x] = unsigned int(max( min (sum0>>8,255),0));
				frameptrs[0][x+1] = unsigned int(max( min (sum1>>8,255),0));
				frameptrs[0][x+2] = unsigned int(max( min (sum2>>8,255),0));
				frameptrs[0][x+3] = unsigned int(max( min (sum3>>8,255),0));
				frameptrs[0][x+4] = unsigned int(max( min (sum4>>8,255),0));
				frameptrs[0][x+5] = unsigned int(max( min (sum5>>8,255),0));
				frameptrs[0][x+6] = unsigned int(max( min (sum6>>8,255),0));
				frameptrs[0][x+7] = unsigned int(max( min (sum7>>8,255),0));
			}
			for (int i=0;i<(length+1)*4;++i)
				frameptrs[i] += pitches[i];
		}
	}
}